import { DatabaseInfo, DatabaseModification, EngineDriver, SqlDialect } from 'dbgate-types';
export declare class DatabaseAnalyser {
    pool: any;
    driver: EngineDriver;
    structure: DatabaseInfo;
    modifications: DatabaseModification[];
    singleObjectFilter: any;
    singleObjectId: string;
    dialect: SqlDialect;
    constructor(pool: any, driver: EngineDriver, version: any);
    _runAnalysis(): Promise<DatabaseInfo>;
    _getFastSnapshot(): Promise<DatabaseInfo>;
    _computeSingleObjectId(): Promise<void>;
    addEngineField(db: DatabaseInfo): DatabaseInfo;
    fullAnalysis(): Promise<DatabaseInfo>;
    singleObjectAnalysis(name: any, typeField: any): Promise<any>;
    incrementalAnalysis(structure: any): Promise<DatabaseInfo>;
    mergeAnalyseResult(newlyAnalysed: any): any;
    getRequestedObjectPureNames(objectTypeField: any, allPureNames: any): any;
    createQuery(template: any, typeFields: any): any;
    createQueryCore(template: any, typeFields: any): any;
    getDeletedObjectsForField(snapshot: any, objectTypeField: any): any;
    getDeletedObjects(snapshot: any): any[];
    feedback(obj: any): void;
    getModifications(): Promise<any[]>;
    analyserQuery(template: any, typeFields: any): Promise<import("dbgate-types").QueryResult>;
    static createEmptyStructure(): DatabaseInfo;
    static byTableFilter(table: any): (x: any) => boolean;
    static extractPrimaryKeys(table: any, pkColumns: any): {
        constraintType: string;
        columns: any;
        pureName: any;
        schemaName: any;
        constraintName: any;
    };
    static extractForeignKeys(table: any, fkColumns: any): {
        columns: Pick<any, any>[];
        constraintName: string;
        constraintType: string;
    }[];
}
