import { ColumnInfo, ConstraintInfo, DatabaseInfo, TableInfo, SqlObjectInfo, NamedObjectInfo } from '../../types';
export declare class DatabaseInfoAlterProcessor {
    db: DatabaseInfo;
    constructor(db: DatabaseInfo);
    createTable(table: TableInfo): void;
    dropTable(table: TableInfo): void;
    createSqlObject(obj: SqlObjectInfo): void;
    dropSqlObject(obj: SqlObjectInfo): void;
    createColumn(column: ColumnInfo): void;
    changeColumn(oldColumn: ColumnInfo, newColumn: ColumnInfo): void;
    dropColumn(column: ColumnInfo): void;
    createConstraint(constraint: ConstraintInfo): void;
    changeConstraint(oldConstraint: ConstraintInfo, newConstraint: ConstraintInfo): void;
    dropConstraint(constraint: ConstraintInfo): void;
    renameTable(table: TableInfo, newName: string): void;
    renameColumn(column: ColumnInfo, newName: string): void;
    renameConstraint(constraint: ConstraintInfo, newName: string): void;
    recreateTable(oldTable: TableInfo, newTable: TableInfo): void;
    fillPreloadedRows(table: NamedObjectInfo, oldRows: any[], newRows: any[], key: string[], insertOnly: string[]): void;
}
