import { SqlDumper } from './SqlDumper';
import { EngineDriver, QueryResult, RunScriptOptions } from 'dbgate-types';
export declare function runCommandOnDriver(pool: any, driver: EngineDriver, cmd: (dmp: SqlDumper) => void): Promise<void>;
export declare function runQueryOnDriver(pool: any, driver: EngineDriver, cmd: (dmp: SqlDumper) => void): Promise<QueryResult>;
export declare const driverBase: {
    analyserClass: any;
    dumperClass: typeof SqlDumper;
    dialect: {
        limitSelect: boolean;
        rangeSelect: boolean;
        offsetFetchRangeSyntax: boolean;
        stringEscapeChar: string;
        fallbackDataType: string;
        quoteIdentifier(s: any): any;
        columnProperties: {
            isSparse: boolean;
            isPersisted: boolean;
        };
        defaultSchemaName: any;
    };
    databaseEngineTypes: string[];
    supportedCreateDatabase: boolean;
    analyseFull(pool: any, version: any): Promise<any>;
    analyseSingleObject(pool: any, name: any, typeField?: string): Promise<any>;
    analyseSingleTable(pool: any, name: any): any;
    analyseIncremental(pool: any, structure: any, version: any): Promise<any>;
    createDumper(options?: any): SqlDumper;
    script(pool: any, sql: any, options: RunScriptOptions): Promise<void>;
    getNewObjectTemplates(): {
        label: string;
        sql: string;
    }[];
    loadFieldValues(pool: any, name: any, columnName: any, search: any): Promise<any>;
    readJsonQuery(pool: any, select: any, structure: any): any;
    showConnectionField: (field: any, values: any) => boolean;
    showConnectionTab: (field: any) => boolean;
};
