import type { ColumnInfo, ConstraintInfo, TableInfo } from 'dbgate-types';
export interface JsonDataObjectUpdateCommand {
    type: 'renameField' | 'deleteField' | 'setField' | 'setFieldIfNull';
    oldField?: string;
    newField?: string;
    value?: any;
}
export interface EditorColumnInfo extends ColumnInfo {
    isPrimaryKey?: boolean;
}
export declare function fillEditorColumnInfo(column: ColumnInfo, table: TableInfo): EditorColumnInfo;
export declare function processJsonDataUpdateCommands(obj: any, commands?: JsonDataObjectUpdateCommand[]): any;
export declare function editorAddColumn(table: TableInfo, column: EditorColumnInfo, addDataCommand?: boolean): TableInfo;
export declare function editorModifyColumn(table: TableInfo, column: EditorColumnInfo, addDataCommand?: boolean): TableInfo;
export declare function editorDeleteColumn(table: TableInfo, column: EditorColumnInfo, addDataCommand?: boolean): TableInfo;
export declare function editorAddConstraint(table: TableInfo, constraint: ConstraintInfo): TableInfo;
export declare function editorModifyConstraint(table: TableInfo, constraint: ConstraintInfo): TableInfo;
export declare function editorDeleteConstraint(table: TableInfo, constraint: ConstraintInfo): TableInfo;
