import { TableInfo, DatabaseInfo } from 'dbgate-types';
export interface ColumnInfoYaml {
    name: string;
    type: string;
    notNull?: boolean;
    length?: number;
    autoIncrement?: boolean;
    references?: string;
    primaryKey?: boolean;
    default?: string;
}
export interface DatabaseModelFile {
    name: string;
    text: string;
    json: {};
}
export interface TableInfoYaml {
    name: string;
    columns: ColumnInfoYaml[];
    primaryKey?: string[];
    insertKey?: string[];
    insertOnly?: string[];
    data?: any[];
}
export interface ForeignKeyInfoYaml {
    deleteAction?: string;
}
export declare function tableInfoToYaml(table: TableInfo): TableInfoYaml;
export declare function tableInfoFromYaml(table: TableInfoYaml, allTables: TableInfoYaml[]): TableInfo;
export declare function databaseInfoFromYamlModel(files: DatabaseModelFile[]): DatabaseInfo;
